﻿Imports System.Data
Imports Infragistics.Web.UI.GridControls

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            ' データの生成
            Dim PrimaryColumn As DataColumn() = New DataColumn(0) {}
            Dim dt As New DataTable()
            PrimaryColumn(0) = dt.Columns.Add("ID", GetType(String))
            dt.Columns.Add("Site", GetType(String))
            dt.Columns.Add("Description", GetType(String))

            dt.Rows.Add("1", "Infragistics", "Infragistics US サイト")
            dt.Rows.Add("2", "Infragistics Japan", "Infragistics Japan サイト")
            dt.Rows.Add("3", "Infragistics Japan online samples", "オンラインサンプル")
            dt.Rows.Add("4", "Infragistics Japan online help", "オンラインヘルプ")
            dt.Rows.Add("5", "Infragistics Japan blogs", "ブログページ")

            dt.PrimaryKey = PrimaryColumn

            Session("data") = dt
        End If

        ' データバインド
        Me.WebDataGrid1.DataSource = Session("data")
    End Sub

    Protected Sub Page_Init(sender As Object, e As System.EventArgs) Handles Me.Init
        ' テンプレート列の生成
        Dim field1 As New TemplateDataField()
        field1.Key = "HyperLinkTemplate"
        field1.Header.Text = "URL"

        ' テンプレート列の ItemTemplate プロパティに描画要素を割り当て
        field1.ItemTemplate = New CustomItemTemplate()

        ' テンプレート列を WebDataGrid に追加
        Me.WebDataGrid1.Columns.Add(field1)
    End Sub

    Private Class CustomItemTemplate
        Implements ITemplate

        Public Sub InstantiateIn(container As System.Web.UI.Control) Implements System.Web.UI.ITemplate.InstantiateIn
            ' HyperLink のデフォルト値
            Dim hyperlink As New HyperLink() With { _
             .ID = "hyperlink", _
             .Text = "Infragistics", _
             .NavigateUrl = "http://www.infragistics.com", _
             .Target = "_blank" _
            }

            container.Controls.Add(hyperlink)
        End Sub
    End Class

    Protected Sub WebDataGrid1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles WebDataGrid1.InitializeRow
        ' 各行の表すサイト名を取得
        Dim text As String = e.Row.Items(1).Text

        ' HyperLinkTemplate 列から HyperLink コントロールを取得
        Dim hyperlink As HyperLink = DirectCast(e.Row.Items(3).FindControl("hyperlink"), HyperLink)

        ' サイト名に応じてリンクを設定
        Select Case text
            Case "Infragistics"
                hyperlink.NavigateUrl = "http://www.infragistics.com"
                Exit Select
            Case "Infragistics Japan"
                hyperlink.NavigateUrl = "http://jp.infragistics.com/"
                Exit Select
            Case "Infragistics Japan online samples"
                hyperlink.NavigateUrl = "http://samples.jp.infragistics.com/"
                Exit Select
            Case "Infragistics Japan online help"
                hyperlink.NavigateUrl = "http://jp.infragistics.com/support/documentation.aspx#2686"
                Exit Select
            Case "Infragistics Japan blogs"
                hyperlink.NavigateUrl = "http://blogs.jp.infragistics.com/blogs/"
                Exit Select
            Case Else
                hyperlink.NavigateUrl = "http://www.infragistics.com"
                Exit Select
        End Select

        ' サイト名を HyperLink の表示テキストに設定
        hyperlink.Text = text
    End Sub
End Class
